import sys

#Make sure we have 2 arg's
try:
    source_file = sys.argv[1]
    destination_file = sys.argv[2]
except IndexError, err:
    print "Usage: timetableconverter.exe in.csv out.cal"
    sys.exit(2)

#Does the Source Files Exist?   
try:
    source = open(source_file, "r")
except IOError, err:
    print "Source file does not exist or is inaccessible"
    sys.exit(2)
    
#Try and create Handle for Destination?   
try:
   destination = open(destination_file, "w")
except IOError, err:
    print "Destination file is inaccessible"
    sys.exit(2)

#Process Input file and 
	
from icalendar import Calendar, Event
from datetime import datetime, date, time, timedelta
from icalendar import UTC

start_date = date.today()
week = 1
line_no = 1

#Setup Calendar
cal = Calendar()
cal.add('prodid', '-//TimetableConverter//lloydsparkes.co.uk//')
cal.add('version', '0.1')

for line in source:
	line_no = line_no + 1
	item = line.split(',')
	if len(item[0].split('/')) == 3:
		#Get the date then move onto next line
		t_date = item[0].split('/')
		start_date = date(int(t_date[2]), int(t_date[1]), int(t_date[0]));
	elif len(item[0].split(' ')) == 2:
		#Increase what Week Number it is
		week = week + 1
		start_date = start_date + timedelta(7)
	elif len(item[0].split('.')) == 2:
		#Check for any Sessions and add a event if need be.
		t_time = item[0].split('.')
		session_start_time = time(int(t_time[0]), int(t_time[1]))
		for i in range(1, 6):
			t_start_date = start_date + timedelta(i-1)
			if item[i].strip() != '' :
				event = Event()
				event.add('dtstart', datetime(t_start_date.year, t_start_date.month, t_start_date.day, session_start_time.hour, session_start_time.minute, 0, tzinfo=UTC))
				event.add('dtend', datetime(t_start_date.year, t_start_date.month, t_start_date.day, session_start_time.hour + 1, session_start_time.minute, 0, tzinfo=UTC))
				event.add('dtstamp', datetime.now(UTC))
				#Modify theses line to change description/summary/location depending on your format
				#My format is "Summary Location"
				sum = item[i].split(' ')
				event.add('summary', sum[0])
				event.add('location', sum[1])
				event.add('prority', '5')
				event['uid'] = str(t_start_date.year) + str(t_start_date.month) + str(t_start_date.day) + 'T' + str(session_start_time.hour) + str(session_start_time.minute) + str(session_start_time.second) + "@lloydsparkes.co.uk"
				cal.add_component(event)
	else :
		print "CSV Phrasing Error: Known Data Item. Line Number: " + str(line_no)
		
#Write Out
destination.write(cal.as_string())
		
#Clean up and Close Handles
source.flush()
source.close()
destination.flush()
destination.close()
